using System;
using System.Collections.Generic;
using System.Text;

using System.Collections.Specialized;
using CMS.EcommerceProvider;

namespace CustomProviders
{
    public class AuthorizeNetProvider : CMSAuthorizeNetProvider
    {
        public override string InitializePaymentRequest(NameValueCollection requestParams)
        {
            string errorMessage = "";

            if (this.ShoppingCartInfoObj != null)
            {
                // Do default payment request initialization
                errorMessage = base.InitializePaymentRequest(requestParams);

                if (errorMessage == "")
                {
                    if (requestParams != null)
                    {
                        // Here you can modify any parameter which is supported by Authorize.Net

                        // Override total price which should be sent to the Authorize.Net
                        requestParams["x_amount"] = Convert.ToString(this.ShoppingCartInfoObj.PaymentGatewayCustomData["price"]);

                        // Override description of the payment
                        requestParams["x_description"] = "Custom description of the order:" + this.ShoppingCartInfoObj.OrderId;
                    }
                    else
                    {
                        errorMessage = "Payment processing faild - payment parameters not found.";
                    }
                }
            }
            else
            {
                errorMessage = "Payment processing faild - Order data not found.";
            }

            return errorMessage;
        }
    }
}
